<?php
set_time_limit(0);

if (is_readable("functions.php"))
    include "functions.php";

if (isset($argv[1])) {
    $skin = $argv[1];
    if ($skin != "eversion") {
        if (!file_exists("skins/".$skin)) {
            print_r("Skin ".$skin." doesnt' exist in skins folder.\n");
            exit;
        }
    }
    setSkin($skin);
    LoadPreferences();
}
else {
    LoadPreferences();
}

$filter_genres = filterGenres();
$filter_mpaa = filterMPAA();
$sdate = trim(shell_exec("date +%y"));
$ldate = trim(shell_exec("date +%Y"));
print_r("Building xml for ".$skin." skin.\n\n");
if ($enable_sqlite3 == "true") {
    $dbh = new PDO('sqlite:oversight.db');
    $ids = readMovieID();
    foreach ($ids as $key => $value){
        $ids = explode(",", $value);
        for ($i=0;$i<count($ids);$i++) {
            $sql = 'SELECT CUSTOM1 FROM SHOWS WHERE CUSTOM1="'.$ids[$i].'"';
            $result = DBQuery($dbh, $sql);
            $row = $result->fetch(PDO::FETCH_ASSOC);
            if (!isset($row['CUSTOM1'])) {
                if (isset($id_not[$key]))
                    $id_not[$key] .= ','.$ids[$i];
                else
                    $id_not[$key] = $ids[$i];
            }
        }
    }

    if (count($id_not) > 0) {
        print_r("Inserting ".count($id_not)." Videos into SQLite3 DB...\n");
        $movies = readIndexData();
        $plot_data = readPlotData();
        $people_data = readPeopleData();
        foreach ($id_not as $key => $value) {
            $ids = explode(",", $value);
            //handleNMJData($dbh, $movies[$key], "inserted");
            if ($movies[$ids[0]]['_C'] == "M") {
                $movies[$ids[0]]['_ID'] = 'MOVIE';
                $count = preg_match("|(.*)\[SET (.*)\]\.(.*)|", trim($movies[$ids[0]]['_F']), $output);
                $title = $movies[$ids[0]]['_T'];
                if ($count > 0) {
                    $title = $movies[$ids[0]]['_T'];
                    $movies[$ids[0]]['CATEGORY'][] = 'Set';
                    $movies[$ids[0]]['_ID'] = 'BOXSET';
                    $movies[$ids[0]]['_T'] = $output[2];
                    $boxset_id = handleShow($dbh, $movies[$ids[0]], "inserted");
                }

                print_r("Inserting Movie ---> ".$movies[$ids[0]]['_T']."\n");
                $movies[$ids[0]]['_T'] = $title;
                $movies[$ids[0]]['_w'] = $movies[$ids[0]]['_w'] ? "true" : "false";
                if ($movies[$ids[0]]['_ID'] == 'BOXSET')
                    $movies[$ids[0]]['_ID'] = $output[2];
                $movies[$ids[0]]['CATEGORY'][] = 'Movies';
                $movies[$ids[0]]['CATEGORY'][] = 'New-Movies';
                handleNMJData($dbh, $movies[$ids[0]], "inserted");
            }
            else {
                $season = explode("_", $key);
                $movies[$ids[0]]['_ID'] = 'SERIES';
                $movies[$ids[0]]['CATEGORY'][] = 'Set';
                $series_id = handleShow($dbh, $movies[$ids[0]], "inserted");

                $movies[$ids[0]]['_ID'] = 'SEASON';
                $movies[$ids[0]]['CATEGORY'][] = '';
                $movies[$ids[0]]['_T'] = $season[0].' Season '.$season[1];
                $season_id = handleShow($dbh, $movies[$ids[0]], "inserted");

                for ($j=0;$j<count($ids);$j++) {
                    $movies[$ids[$j]]['_ID'] = 'EPISODE';
                    if (isset($movies[$ids[$j]]['_et']))
                        $movies[$ids[$j]]['_T'] = $movies[$ids[$j]]['_et'];
                    else if (isset($movies[$ids[$j]]['_ai']))
                        $movies[$ids[$j]]['_T'] = $movies[$ids[$j]]['_ai'];
                    print_r("Inserting TV Show ---> ".$season[0]." - Season ".$season[1]." : ".$movies[$ids[$j]]['_T']."\n");
                    if ($movies[$ids[$j]]['_e'] == '')
                        $movies[$ids[$j]]['_e'] = '0';
                    $episodes = explode(",", $movies[$ids[$j]]['_e']);
                    $movies[$ids[$j]]['EPISODE'] = $episodes[0];
                    $movies[$ids[$j]]['SEASON_ID'] = $season_id;
                    $movies[$ids[$j]]['SERIES_ID'] = $series_id;
                    $movies[$ids[$j]]['SEASON'] = $season[1];
                    $movies[$ids[$j]]['_w'] = $movies[$ids[$j]]['_w'] ? "true" : "false";
                    $movies[$ids[0]]['CATEGORY'][] = 'TV Shows';
                    $movies[$ids[0]]['CATEGORY'][] = 'New-TV';
                    handleNMJData($dbh, $movies[$ids[$j]], "inserted");
                }
            }
        }
    }
    $sql = "SELECT TITLE,CUSTOM1 FROM SHOWS WHERE CUSTOM2!='EPISODE' AND CUSTOM2!='SEASON'";
    $sql.= " AND CUSTOM2!='BOXSET' ORDER BY TITLE";
    foreach ($dbh->query($sql) as $row) {
        $tmparr = array();
        $tmparr[] = $row['TITLE'];
        $tmparr[] = $row['CUSTOM1'];
        $movies[$row['TITLE']] = $tmparr;
    }
}
else {
    $movies = readIndexData();
    $plot_data = readPlotData();
    $people_data = readPeopleData();
    ksort($movies);
}
buildMovieDetailsXML($dbh);
exit;
if ($skin != "eversion")
    buildMovieDetailsHTML();

print_r("Indexing libraries...\n");
$categories = FindCategories('commandline');
print_r("Categories created.\n");
buildCategoryXML();

function buildMovieDetailsXML($dbh)
{
    global $movies, $skin, $enable_sqlite3;
    $keys = array_keys($movies);

    $totcnt = count($keys);
    $cnt = 0;
    print_r("Building Details XML...\n");
    foreach ($keys as $key) {
        $cnt++;
        if ($enable_sqlite3 == "true")
            $id = $movies[$key][1];
        else
            $id = $movies[$key][0]['_id'];
        $xmlfilename = "details_".$id;
        $rebuild = 1;
        if (file_exists("xml/" . $xmlfilename . ".xml") && filesize ("xml/" . $xmlfilename . ".xml") > 0) {
            $rebuild = 0;
            $order = findOrder($key);
            if ($enable_sqlite3 == "true") {
                $first = $movies[$order[0]][1];
                $last = $movies[$order[1]][1];
                $previous = $movies[$order[2]][1];
                $next = $movies[$order[3]][1];
            }
            else {
                $first = $movies[$order[0]][0]['_id'];
                $last = $movies[$order[1]][0]['_id'];
                $previous = $movies[$order[2]][0]['_id'];
                $next = $movies[$order[3]][0]['_id'];
            }
            $xml_parser = xml_parser_create();
            $xdata = file_get_contents("xml/" . $xmlfilename . ".xml");
            xml_parse_into_struct($xml_parser, $xdata, $tags, $index);
            xml_parser_free($xml_parser);
            
            foreach ($tags as $xmlelem) {
                if ($xmlelem['tag'] == 'FIRST') {
                    if ($xmlelem['value'] != "details_".$first)
                        $rebuild = 1;
                    break;
                }
                if ($xmlelem['tag'] == 'PREVIOUS') {
                    if ($xmlelem['value'] != "details_".$previous)
                        $rebuild = 1;
                    break;
                }
                if ($xmlelem['tag'] == 'NEXT') {
                    if ($xmlelem['value'] != "details_".$next)
                        $rebuild = 1;
                    break;
                }
                if ($xmlelem['tag'] == 'LAST') {
                    if ($xmlelem['value'] != "details_".$last)
                        $rebuild = 1;
                    break;
                }
            }
        }
        if ($enable_sqlite3 == "true")
            $movies[$key]['rebuild'] = $rebuild;
        else
            $movies[$key][0]['rebuild'] = $rebuild;

        if ($rebuild == 1) {
            print("Writing XML data (".$cnt."/".$totcnt.") ...\r");
            $xmldata = "<?xml version='1.0' encoding='UTF-8'?>\n";
            $xmldata .= "<details>\n";
            $xmldata .= getMovieXML($dbh, $key, "detail", "static", $rebuild, NULL);
            $xmldata .= "</details>\n";
            file_put_contents("xml/" . $xmlfilename . ".xml", $xmldata);
        }
    }
    print("\n");
}

function buildMovieDetailsHTML()
{
    global $movies, $skin;
    $keys = array_keys($movies);

    $totcnt = count($keys);
    $cnt = 0;
    print_r("Building Details HTML...\n");
    foreach ($keys as $key) {
        $cnt++;
        $xmlfilename = "details_".$movies[$key][0]['_id'];
        if (($movies[$key][0]['rebuild'] == 1 ) || (! file_exists("html/" . $xmlfilename . ".html")) ||
                (file_exists("html/" . $xmlfilename . ".html") && filesize("html/" . $xmlfilename . ".html") == 0)) {
            print("Writing HTML data (".$cnt."/".$totcnt.") ...\r");
            buildHTML("skins/".$skin."/detail.xsl", $xmlfilename);
        }
    }
    print("\n");
}

function buildCategoryXML()
{
    global $movies, $skin;
    $catxmldata = buildCategoriesXML2();
    if (!file_exists("xml/Categories.xml")) {
        print("Writing Categories XML...\n");
        $xmldata = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
        $xmldata .= "<library count=\"5\">\n";
        $xmldata .= implode("", $catxmldata);
        $xmldata .= "</library>";
        file_put_contents("xml/Categories.xml", $xmldata);
    }
    if ($skin != "eversion") {
        print("Writing Categories HTML...\n");
        buildHTML("skins/".$skin."/categories.xsl", "Categories");
        shell_exec("cd html;rm -f index.htm;ln -s Categories.html index.htm");
    }
    buildIndexXML($catxmldata);
}

function buildIndexXML($catxmldata)
{
    global $categories, $skin;
    if ($skin == "eversion")
        $no_movies_page = 20;
    else
        $no_movies_page = 27;
    $catnames = array_keys($categories);
    $totcat = count($catnames);
    $cat = 0;
    $indexxml = array();
    print("Writing Indexes XML...\n");
    foreach ($catnames as $catname) {
        $cat++;
        $catcount = 0;
        foreach ($categories[$catname] as $catdetail) {
            $catcount++;
            $fmovies = fetchMovies($catname, $catdetail);
            $numMoviesAvail = count($fmovies);
            $balance = $numMoviesAvail % $no_movies_page;
            if ($balance == 0)
                $totIndex = $numMoviesAvail / $no_movies_page;
            else
                $totIndex = (($numMoviesAvail - $balance) / $no_movies_page) + 1;

            $ids = array_keys($fmovies);
            for ($j = 0; $j < $totIndex; $j++) {
                $search = array("/", ":", "?", "\\", ">", "<", "*");
                $mod_catdetail = str_replace($search, " ", htmlspecialchars_decode($catdetail, ENT_QUOTES));
                $catfilename = $catname . "_" . $mod_catdetail . "_" . ($j + 1);
                $data = '';
                for ($k = $j * $no_movies_page; $k < ($j + 1) * $no_movies_page; $k++) {
                    if ($k + 1 <= $numMoviesAvail) {
                        $data .= getMovieXML($dbh, $ids[$k], "detail", "static", 0, $fmovies[$ids[$k]]);
                    }
                }
                $xmldata = "<?xml version='1.0' encoding='UTF-8'?>\n";
                $xmldata .= "<library>\n";
                $xmldata .= buildIndexCategoriesXML($catname, $catdetail, $j + 1, $totIndex, $catxmldata);
                print("  Indexing ".$catname." XML (".$cat."/".$totcat.") contains ".$catcount." indexes\r");
                $xmldata .= "  <movies count=\"".$no_movies_page."\" cols=\"9\">\n";
                $xmldata .= $data;
                $xmldata .= "  </movies>\n";
                $xmldata .= "</library>\n";
                file_put_contents("xml/". $catfilename. ".xml", $xmldata);
                $indexxml[] = $catfilename;
            }
        }
        print_r("\n");
    }
    if ($skin != "eversion")
        buildIndexHTML($indexxml);
}

function buildIndexHTML($indexxml)
{
    global $skin;
    $totcnt = count($indexxml);
    $cnt = 0;
    foreach ($indexxml as $xml) {
        $cnt++;
        print("Writing Indexes HTML (".$cnt."/".$totcnt.")...\r");
        buildHTML("skins/".$skin."/index.xsl", $xml);
    }
    print_r("\n");
}

?>
