<?php
set_time_limit(120);
foreach ($_GET as $variable => $value) {
    $_GET[str_replace('amp;', '', $variable)] = $value;
}

ob_start();

if (is_readable("functions.php"))
    include "functions.php";

if (isset($_GET['xml'])) {
    $xml = explode("=", $_SERVER['REQUEST_URI']);
    $_GET['xml'] = urldecode(str_replace("&xsl", "", $xml[1]));
    $other = explode("_", str_replace("\\", "", $_GET['xml']));
    $maincat = $other[0];
    if (count($other) == 2)
        $maincat = implode("_", $other);
    if (isset($other[1]))
        $subcat = $other[1];
    if (isset($other[2]))
        $currentPage = $other[2];
    $actual = $_GET['xml'];
}
else
    $maincat = 'Categories.xml';

if (isset($_GET['xsl']))
    $xslfile = $_GET['xsl'];
else
    $xslfile = "categories.xsl";

if (isset($_GET['oricat'])) {
    $oricat = $_GET['oricat'];
    $is_set = explode("_", $oricat);
    if ($is_set[1] == "Sets"){
        $subcat = $maincat;
        $maincat = "Set";
        $xslfile = "index.xsl";
        $oricat = "";
        $currentPage = 1;
    }
}
else
    $oricat = "";

global $skin;
LoadPreferences();
$xslfile_fullpath = "skins/".$skin."/" . $xslfile;

$data = file_get_contents($xslfile_fullpath);
$data = preg_replace('/<xsl:include href="(.*)"/', '<xsl:include href="skins/'.$skin.'/$1"', $data);
$data = preg_replace('/<xsl:import href="(.*)"/', '<xsl:import href="skins/'.$skin.'/$1"', $data);

$data = patchXSL($xslfile, $data, $oricat);

$dbh = new PDO('sqlite:oversight.db');
$categories = GetCategories($dbh);
$catxmldata = buildCategoriesXML2();
$sdate = trim(shell_exec("date +%y"));
$ldate = trim(shell_exec("date +%Y"));

$cache_time = 3600;
$cache_folder = 'tmp/cache';
$cache_filename = $cache_folder.md5($_SERVER['REQUEST_URI']);
$cache_created  = (file_exists($cache_filename)) ? filemtime($cache_filename) : 0;
if ((time() - $cache_created) < $cache_time) {
    readfile($cache_filename); // The cached copy is still valid, read it into the output buffer 
}
else {

if ($maincat == "Categories.xml") {
    $xmldata = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    $xmldata .= "<library count=\"5\">\n";
    $xmldata .= implode("", $catxmldata);
    $xmldata .= "</library>";
}
else if ($maincat == "Other" || $maincat == "Genres" || $maincat == "Title"
    || $maincat == "Rating" || $maincat == "Year" || $maincat == "Set"
    || $maincat == "Cast" || $maincat == "Director") {
    $fmovies = fetchMovies($dbh, $maincat, $subcat);
    
    $numMoviesAvail = count($fmovies);
    $balance = $numMoviesAvail % 27;
    if ($balance == 0)
        $totIndex = $numMoviesAvail / 27;
    else
        $totIndex = (($numMoviesAvail - $balance) / 27) + 1;

    $xdata = '';
    $currIndex = $currentPage - 1;
    $lastIndex = 27 * $currentPage;
    $movie_title = array_keys($fmovies);
    for ($k = $currIndex * 27; $k < $lastIndex; $k++) {
        if ($k + 1 <= $numMoviesAvail)
            $xdata .= getMovieXML($dbh, $fmovies[$movie_title[$k]], "index", "dynamic", 0, $fmovies);
    }
    $xmldata = "<?xml version='1.0' encoding='UTF-8'?>\n";
    $xmldata .= "<library>\n";
    $xmldata .= buildIndexCategoriesXML($maincat, $subcat, $currentPage, $totIndex, $catxmldata, "aeon");
    $xmldata .= "    <movies count=\"27\" cols=\"9\">\n";
    $xmldata .= $xdata;
    $xmldata .= "    </movies>\n";
    $xmldata .= "</library>\n";
}
else {
    $mcat = explode("_", $oricat);
    $fmovies = fetchMovies($dbh, $mcat[0], $mcat[1]);
    $xmldata = "<?xml version='1.0' encoding='UTF-8'?>\n";
    $xmldata .= "<details>\n";
    $xmldata .= getMovieXML($dbh, $fmovies[$maincat], "detail", "dynamic", 0, $fmovies);
    $xmldata .= "</details>\n";
}

$xsl = new XSLTProcessor();

if (!$xsl->hasExsltSupport()) {
    die('EXSLT support not available');
}

$xsldoc = new DOMDocument();
$xmldoc = new DOMDocument();
$xsldoc->loadXML($data);
$xsl->importStyleSheet($xsldoc);

$xmldoc->loadXML($xmldata);
$output = $xsl->transformToXML($xmldoc);
$search = array("Other_All_1.html", "Title_A_1.html", "Other_Tv Shows_1.html");
$replace = array("?xml=Other_All_1&amp;xsl=index.xsl",
    "?xml=Title_A_1&amp;xsl=index.xsl",
    "?xml=Other_Tv Shows_1&amp;xsl=index.xsl");
$output = str_replace($search, $replace, $output);
if ($xslfile != "categories.xsl") {
    $search = array('pictures/',
        'exportdetails_item_popcorn.css',
        'exportindex_item_pch.css');
    $replace = array('skins/'.$skin.'/html/pictures/',
        'skins/'.$skin.'/html/exportdetails_item_popcorn.css',
        'skins/'.$skin.'/html/exportindex_item_pch.css');
    $output = str_replace($search, $replace, $output);
}
echo $output;
$contents = ob_get_contents();
file_put_contents($cache_filename, $contents);
}
ob_end_flush();
?>
